"use strict";
var should = require('should'), mqtt = require('mqtt'), mqttConnect = require('../lib/mqtt/mqttConnect');

describe('MQTT - Lighting', function () {
    beforeEach(function () {
        mqttConnect.doConnection();
    });

    it('should create client', function (done) {
        mqttConnect.client.should.be.instanceOf(mqtt.MqttClient);
        done();
    });

    it('should connect to IBM', function (done) {
        mqttConnect.client.on('connect', function () {
                done();
            })
            .on('error', function (err) {
                done(err);
            });
    });

    it('should turn the projector ON', function (done) {
        mqttConnect.client.on('connect', function () {
                mqttConnect.projectorOn(function (err) {
                    should.not.exist(err);
                });
                done();
            })
            .on('error', function (err) {
                done(err);
            });

    });

    it('should turn the projector OFF', function (done) {
        mqttConnect.client.on('connect', function () {
                mqttConnect.projectorOff(function (err) {
                    should.not.exist(err);
                });
                done();
            })
            .on('error', function (err) {
                done(err);
            });

    });

    it('should turn the heating ON', function (done) {
        mqttConnect.client.on('connect', function () {
                mqttConnect.heatingOn(function (err) {
                    should.not.exist(err);
                });
                done();
            })
            .on('error', function (err) {
                done(err);
            });

    });

    it('should turn the heating OFF', function (done) {
        mqttConnect.client.on('connect', function () {
                mqttConnect.heatingOff(function (err) {
                    should.not.exist(err);
                });
                done();
            })
            .on('error', function (err) {
                done(err);
            });
    });

    it('should turn the front light ON', function (done) {
        mqttConnect.client.on('connect', function () {
                mqttConnect.lightingOn('1',function (err) {
                    should.not.exist(err);
                });
                done();
            })
            .on('error', function (err) {
                done(err);
            });
    });

    it('should turn the middle light ON', function (done) {
        mqttConnect.client.on('connect', function () {
                mqttConnect.lightingOn('2',function (err) {
                    should.not.exist(err);
                });
                done();
            })
            .on('error', function (err) {
                done(err);
            });
    });

    it('should turn the back light ON', function (done) {
        mqttConnect.client.on('connect', function () {
                mqttConnect.lightingOn('3',function (err) {
                    should.not.exist(err);
                });
                done();
            })
            .on('error', function (err) {
                done(err);
            });
    });

    it('should turn the front light OFF', function (done) {
        mqttConnect.client.on('connect', function () {
                mqttConnect.lightingOff('a',function (err) {
                    should.not.exist(err);
                });
                done();
            })
            .on('error', function (err) {
                done(err);
            });
    });

    it('should turn the middle light OFF', function (done) {
        mqttConnect.client.on('connect', function () {
                mqttConnect.lightingOff('b',function (err) {
                    should.not.exist(err);
                });
                done();
            })
            .on('error', function (err) {
                done(err);
            });
    });

    it('should turn the back light OFF', function (done) {
        mqttConnect.client.on('connect', function () {
                mqttConnect.lightingOff('c',function (err) {
                    should.not.exist(err);
                });
                done();
            })
            .on('error', function (err) {
                done(err);
            });
    });
});